/*============================================================================
//	Axpad03w.cs
//
//	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.
//
//==========================================================================*/
using System;
using System.Drawing;
using System.Collections;
using System.ComponentModel;
using System.Windows.Forms;
using System.Data;
using System.Runtime.InteropServices;

namespace SampleAd03
{
	/// <summary>
	/// Axpad03w ̊Tv̐łB
	/// </summary>
	public class Axpad03w
	{
		private int mErrWradll = SUCCESS;	// bp[֐G[

		/* Errors */
		public const int	SUCCESS						= 0;	/* Successfully proccessed */
		public const int	ERR_SYSTEM					= 1;	/* Call GetLastError() */
		public const int	ERR_NO_DEVICE				= 2;	/* No card */
		public const int	ERR_IN_USE					= 3;	/* Device is in use */
		public const int	ERR_INVALID_SOCKET			= 4;	/* Invalid logical Socket */
		public const int	ERR_RESOURCE				= 5;	/* Resource exhaustion */
		public const int	ERR_ILLEGAL_FUNCTION_CALL	= 6;	/* Illegal Function Call */
		public const int	ERR_INVALID_ARGUMENT		= 7;	/* Invalid argument */
		public const int	ERR_NUMDATA					= 8;	/* Invalid Number of Data */
		public const int	ERR_INTERNAL				= 9;	/* Internal Error */
		public const int	ERR_WRAPDLL					= -1;	// bp[֐G[

		/* other */
		public const short	SOCKET_AUTO					= -1;	/* I[gT[` */
		public const int	MAX_SOCKETS					= 16;	/* T|[g\Pbg */
		public const int	NUM_CHANNELS				= 2;	/* `l */

		/* Message */
		public const int	WM_BUFF_FULL				= 0;	/* obt@(FIFO)t */
		public const int	WM_CARD_REMOVAL				= 1;	/* J[h */

		/* Sampling Status */
		public const int	STS_SAMPLING				= 0x01;	/* TvO */
		public const int	STS_BUFF_FULL				= 0x02;	/* obt@(FIFO)t */
		public const int	STS_HOLDOFF_ERROR			= 0x04;	/* HOLD OFF G[ */

		/* Resource infomation structure */
		public const int	MAX_MEM						= 9;
		public const int	MAX_IO						= 20;
		public const int	MAX_IRQ						= 7;
		public const int	MAX_DMA						= 7;
		public const int	MAX_RSV						= 3;

		[StructLayout(LayoutKind.Sequential)]
		public struct Resource
		{
			public int		dwNumMemWindows;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemLength;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_MEM)]
			public int[]	dwMemAttrib;
			public int		dwNumIOPorts;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortBase;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IO)]
			public int[]	dwIOPortLength;
			public int		dwNumIRQs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQRegisters;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_IRQ)]
			public int[]	dwIRQAttrib;
			public int		dwNumDMAs;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMALst;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_DMA)]
			public int[]	dwDMAAttrib;
			[MarshalAs(UnmanagedType.ByValArray,SizeConst = MAX_RSV)]
			public int[]	dwReserved1;
		}

		/* Mode structure */
		[StructLayout(LayoutKind.Sequential)]
		public struct Mode
		{
			public int	dwSampleTime;		/* Sampling time */
			public int	dwTrigMode;			/* Trigger mode */
			public int	dwTrigSource;		/* Trigger Source */
			public int	dwTrigSlope;		/* Trigger Slope */
			public int	dwTrigLevel;		/* Trigger Level */
			public int	dwTrigPosition;		/* Trigger Position */
			public int	dwTrigDelay;		/* Trigger Delay time */
			public int	dwTrigHoldOff;		/* Trigger HoldOff time */
		};

		// API
		[DllImport("axpad03.dll")]
		public extern static unsafe bool Ad03GetVersion(int* pdwDllVersion, int* pdwDrvVersion);
		[DllImport("axpad03.dll")]
		public extern static unsafe bool Ad03Create(short* pwLogSocket, int hWnd, short uWMBase);
		[DllImport("axpad03.dll")]
		public extern static        bool Ad03Close(short wLogSocket);
		[DllImport("axpad03.dll")]
		public extern static        bool Ad03GetResource(short wLogSocket, ref Resource pres);
		[DllImport("axpad03.dll")]
		public extern static        bool Ad03SetMode(short wLogSocket, ref Mode pcmode);
		[DllImport("axpad03.dll")]
		public extern static        bool Ad03StartSampling(short wLogSocket);
		[DllImport("axpad03.dll")]
		public extern static        bool Ad03StopSampling(short wLogSocket);
		[DllImport("axpad03.dll")]
		public extern static unsafe bool Ad03GetSamplingStatus(short wLogSocket, int* pdwNumData, int* pdwStatus);
		[DllImport("axpad03.dll")]
		public extern static unsafe bool Ad03GetData(short wLogSocket, int cwNumData, short* pwData);
		[DllImport("axpad03.dll")]
		public extern static        int  Ad03GetLastError(short wLogSocket);

		public Axpad03w()
		{
			// 
			// TODO: RXgN^ WbNɒǉĂB
			//
		}

		/*****************************************************************************/
		/* 	  AXP-AD03 DLL,Vxd̃o[Wԍ擾								 */
		/* 	  pdwDllVersion DLLo[Wԍi[AhX					 */
		/*		  pdwDrvVersion Drvo[Wԍi[AhX					 */
		/* ߂l  true															 */
		/*		  s false														 */
		/*****************************************************************************/
		public unsafe bool GetVersion(int* pdwDllVersion, int* pdwDrvVersion)
		{
			try {
				return Ad03GetVersion(pdwDllVersion, pdwDrvVersion);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD03 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}
		/*****************************************************************************/
		/* 	  AXP-AD03̔Cӂ̃foCX̎gp錾								 */
		/* 	  pwLogSocket gpfoCXi[AhX					 */
		/*		  hWnd		荞݂ƂbZ[W𑗂EBhEnh */
		/*        uWMBase   bZ[Wԍ̃x[X                                   */
		/* ߂l  true															 */
		/*		  s false														 */
		/*****************************************************************************/
		public unsafe bool Create(short* pwLogSocket, int hWnd, short uWMBase)
		{
			try {
				return Ad03Create(pwLogSocket, hWnd, uWMBase);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD03 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}
		/*****************************************************************************/
		/* 	  AXP-AD03̔Cӂ̃foCX̎gpJ								 */
		/* 	  wLogSocket gpfoCX										 */
		/* ߂l  true															 */
		/*		  s false														 */
		/*****************************************************************************/
		public bool Close(short wLogSocket)
		{
			try {
				return Ad03Close(wLogSocket);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD03 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}
		/*****************************************************************************/
		/* 	  wfoCX̃\[X擾									 */
		/* 	  wLogSocket ׂfoCX											 */
		/*		  pres	   \[Xi[\̂̃AhX					 */
		/* ߂l  true															 */
		/*		  s false														 */
		/*****************************************************************************/
		public bool GetResource(short wLogSocket, ref Resource pres)
		{
			try {
				return Ad03GetResource(wLogSocket, ref pres);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD03 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}
		/*****************************************************************************/
		/* 	  TvO[h̐ݒ											 */
		/* 	  wLogSocket ݒ肷foCX										 */
		/*		  pcmode   [hݒf[^̃AhX								 */
		/* ߂l  true															 */
		/*		  s false														 */
		/*****************************************************************************/
		public bool SetMode(short wLogSocket, ref Mode pcmode)
		{
			try {
				return Ad03SetMode(wLogSocket, ref pcmode);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD03 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}
		/*****************************************************************************/
		/* 	  TvOJn													 */
		/* 	  wLogSocket JnfoCX										 */
		/* ߂l  true															 */
		/*		  s false														 */
		/*****************************************************************************/
		public bool StartSampling(short wLogSocket)
		{
			try {
				return Ad03StartSampling(wLogSocket);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD03 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}
		/*****************************************************************************/
		/* 	  TvO~													 */
		/* 	  wLogSocket ~foCX										 */
		/* ߂l  true															 */
		/*		  s false														 */
		/*****************************************************************************/
		public bool StopSampling(short wLogSocket)
		{
			try {
				return Ad03StopSampling(wLogSocket);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD03 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}
		/*****************************************************************************/
		/* 	  TvOEXe[^X̎擾									 */
		/* 	  wLogSocket	 擾foCX									 */
		/*		  pdwNumData f[^obt@AhX								 */
		/*		  pdwStatus	 Xe[^XAhX										 */
		/* ߂l  true															 */
		/*		  s false														 */
		/*****************************************************************************/
		public unsafe bool GetSamplingStatus(short wLogSocket, int* pdwNumData, int* pdwStatus)
		{
			try {
				return Ad03GetSamplingStatus(wLogSocket, pdwNumData, pdwStatus);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD03 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}
		/*****************************************************************************/
		/* 	  TvOς݃f[^̎擾										 */
		/* 	  wLogSocket	擾foCX									 */
		/*		  dwNumData vf[^											 */
		/*		  pwData	f[^obt@ւ̃AhX								 */
		/* ߂l  true															 */
		/*		  s false														 */
		/*****************************************************************************/
		public unsafe bool GetData(short wLogSocket, int dwNumData, short* pwData)
		{
			try {
				return Ad03GetData(wLogSocket, dwNumData, pwData);
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD03 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = ERR_WRAPDLL;	// bp[֐G[
				return false;
			}
		}
		/*****************************************************************************/
		/* 	  AXP-AD03̃G[R[h											 */
		/* 	  wLogSocket	G[foCX							 */
		/* ߂l G[R[h														 */
		/*****************************************************************************/
		public int GetLastError(short wLogSocket)
		{
			try {
				if (mErrWradll == ERR_WRAPDLL) {	// bp[֐G[Ȃ
					mErrWradll = SUCCESS;			// NA
					return ERR_WRAPDLL;
				} else {
					return Ad03GetLastError(wLogSocket);
				}
			}
			catch (Exception e) {
				MessageBox.Show(e.Message, "AXP-AD03 ERROR",
								MessageBoxButtons.OK, MessageBoxIcon.Exclamation);
				mErrWradll = SUCCESS;	// bp[֐G[
				return ERR_WRAPDLL;
			}
		}
	}
};
