/*****************************************************************************/
/*	axpad03w.c																 */
/*																			 */
/*	AXP-AD03															 */
/*																			 */
/*	Copyright ADTEK SYSTEM SCIENCE Co.,Ltd.									 */
/*																			 */
/*****************************************************************************/

#include <windows.h>
#include <tchar.h>

#include "axpad03w.h"	// axpad03

/*---------- X^eBbN֐ -----------------------------------------------*/
static BOOL Ad03wGetDllExportFunc(void);

/*---------- X^eBbNϐ(萔) -----------------------------------------*/
static HMODULE hDLL = NULL;

// DLL GNX|[g֐AhX̊i[ϐ
static FARPROC pAd03GetVersion;
static FARPROC pAd03Create;
static FARPROC pAd03Close;
static FARPROC pAd03GetResource;
static FARPROC pAd03SetMode;
static FARPROC pAd03StartSampling;
static FARPROC pAd03StopSampling;
static FARPROC pAd03GetSamplingStatus;
static FARPROC pAd03GetData;
static FARPROC pAd03GetLastError;

/*****************************************************************************/
/* 	  axpad03.dll[h												 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Ad03wDllOpen(void)
{
	if (hDLL != NULL) return FALSE;
	hDLL = (HMODULE)LoadLibrary(AD03_DLL_NAME);
	if (hDLL == NULL) return FALSE;

	if (Ad03wGetDllExportFunc() == FALSE) {
		Ad03wDllClose();// DLL GNX|[g֐擾ɎŝŁADLL N[Y
		return FALSE;
	}
	return TRUE;
}

/*****************************************************************************/
/* 	  axpad03.dllA[h											 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Ad03wDllClose(void)
{
	if (hDLL == NULL) return TRUE;
	if (FreeLibrary(hDLL) == TRUE) { hDLL = NULL; return TRUE; }
	return FALSE;
}
/*****************************************************************************/
/* 	  AXP-AD03 DLL,Vxd̃o[Wԍ擾								 */
/* 	  pdwDllVersion DLLo[Wԍi[AhX					 */
/*		  pdwVxdVersion Vxdo[Wԍi[AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Ad03wGetVersion(PDWORD pdwDllVersion,PDWORD pdwVxdVersion)
{
	if (hDLL == NULL) return FALSE;
	return (*pAd03GetVersion)(pdwDllVersion,pdwVxdVersion);
}
/*****************************************************************************/
/* 	  AXP-AD03̔Cӂ̃foCX̎gp錾								 */
/* 	  pwLogSocket gpfoCXi[AhX					 */
/*		  hWnd		荞݂ƂbZ[W𑗂EBhEnh */
/*        uWMBase   bZ[Wԍ̃x[X                                   */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Ad03wCreate(PWORD pwLogSocket,HWND hWnd,UINT uWMBase)
{
	if (hDLL == NULL) return FALSE;
	return (*pAd03Create)(pwLogSocket,hWnd,uWMBase);
}
/*****************************************************************************/
/* 	  AXP-AD03̔Cӂ̃foCX̎gpJ								 */
/* 	  wLogSocket gpfoCX										 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Ad03wClose(WORD wLogSocket)
{
	if (hDLL == NULL) return FALSE;
	return (*pAd03Close)(wLogSocket);
}
/*****************************************************************************/
/* 	  wfoCX̃\[X擾									 */
/* 	  wLogSocket ׂfoCX											 */
/*		  pres	   \[Xi[\̂̃AhX					 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Ad03wGetResource(WORD wLogSocket,PAD03R pres)
{
	if (hDLL == NULL) return FALSE;
	return (*pAd03GetResource)(wLogSocket,pres);
}
/*****************************************************************************/
/* 	  TvO[h̐ݒ											 */
/* 	  wLogSocket ݒ肷foCX										 */
/*		  pcmode   [hݒf[^̃AhX								 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Ad03wSetMode(WORD wLogSocket,PCAD03M pcmode)
{
	if (hDLL == NULL) return FALSE;
	return (*pAd03SetMode)(wLogSocket,pcmode);
}
/*****************************************************************************/
/* 	  TvOJn													 */
/* 	  wLogSocket JnfoCX										 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Ad03wStartSampling(WORD wLogSocket)
{
	if (hDLL == NULL) return FALSE;
	return (*pAd03StartSampling)(wLogSocket);
}
/*****************************************************************************/
/* 	  TvO~													 */
/* 	  wLogSocket ~foCX										 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Ad03wStopSampling(WORD wLogSocket)
{
	if (hDLL == NULL) return FALSE;
	return (*pAd03StopSampling)(wLogSocket);
}
/*****************************************************************************/
/* 	  TvOEXe[^X̎擾									 */
/* 	  wLogSocket	 擾foCX									 */
/*		  pcwNumData f[^obt@AhX								 */
/*		  pdwStatus	 Xe[^XAhX										 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Ad03wGetSamplingStatus(WORD wLogSocket,PDWORD pcwNumData,PDWORD pdwStatus)
{
	if (hDLL == NULL) return FALSE;
	return (*pAd03GetSamplingStatus)(wLogSocket,pcwNumData,pdwStatus);
}
/*****************************************************************************/
/* 	  TvOς݃f[^̎擾										 */
/* 	  wLogSocket	擾foCX									 */
/*		  cwNumData vf[^											 */
/*		  pwData	f[^obt@ւ̃AhX								 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*****************************************************************************/
BOOL Ad03wGetData(WORD wLogSocket,DWORD cwNumData,PWORD pwData)
{
	if (hDLL == NULL) return FALSE;
	return (*pAd03GetData)(wLogSocket,cwNumData,pwData);
}
/*****************************************************************************/
/* 	  AXP-AD03̃G[R[h											 */
/* 	  wLogSocket	G[foCX							 */
/* ߂l G[R[h														 */
/*****************************************************************************/
DWORD Ad03wGetLastError(WORD wLogSocket)
{
	if (hDLL == NULL) return AD03_ERR_WRAPDLL;
	return (*pAd03GetLastError)(wLogSocket);
}
/*---------------------------------------------------------------------------*/
/* 	  DLLGNX|[g֐AhX̎擾									 */
/* 	  																 */
/* ߂l  TRUE															 */
/*		  s FALSE														 */
/*---------------------------------------------------------------------------*/
static BOOL Ad03wGetDllExportFunc(void)
{
	// Ad03GetVersion ̃AhX擾
	pAd03GetVersion = GetProcAddress(hDLL, "Ad03GetVersion");
	if (pAd03GetVersion == NULL) return FALSE;

	// Ad03Create ̃AhX擾
	pAd03Create = GetProcAddress(hDLL, "Ad03Create");
	if (pAd03Create == NULL) return FALSE;

	// Ad03Close ̃AhX擾
	pAd03Close = GetProcAddress(hDLL, "Ad03Close");
	if (pAd03Close == NULL)	return FALSE;

	// Ad03GetResource ̃AhX擾
	pAd03GetResource = GetProcAddress(hDLL, "Ad03GetResource");
	if (pAd03GetResource == NULL) return FALSE;

	// Ad03SetMode ̃AhX擾
	pAd03SetMode = GetProcAddress(hDLL, "Ad03SetMode");
	if (pAd03SetMode == NULL) return FALSE;

	// Ad03StartSampling ̃AhX擾
	pAd03StartSampling = GetProcAddress(hDLL, "Ad03StartSampling");
	if (pAd03StartSampling == NULL)	return FALSE;

	// Ad03StopSampling ̃AhX擾
	pAd03StopSampling = GetProcAddress(hDLL, "Ad03StopSampling");
	if (pAd03StopSampling == NULL) return FALSE;

	// Ad03GetSamplingStatus ̃AhX擾
	pAd03GetSamplingStatus = GetProcAddress(hDLL, "Ad03GetSamplingStatus");
	if (pAd03GetSamplingStatus == NULL)	return FALSE;

	// Ad03GetData ̃AhX擾
	pAd03GetData = GetProcAddress(hDLL, "Ad03GetData");
	if (pAd03GetData == NULL) return FALSE;

	// Ad03GetLastError ̃AhX擾
	pAd03GetLastError = GetProcAddress(hDLL, "Ad03GetLastError");
	if (pAd03GetLastError == NULL) return FALSE;

	return TRUE;	// SĂ DLL GNX|[g֐AhX擾
}
