Attribute VB_Name = "DLLDef"
'-------------------------------------------------------------------
'   AXAD03.H AXP-AD03 Windows95 API
'   (C) Copyright ADTEK SYSTEM SCIENCE Corp. 1998
'   Ver 1.00
'-------------------------------------------------------------------

Option Explicit

' Errors
Global Const AD03_SUCCESS = 0                   ' Successfully proccessed
Global Const AD03_ERR_SYSTEM = 1                ' Call GetLastError()
Global Const AD03_ERR_NO_DEVICE = 2             ' No card
Global Const AD03_ERR_IN_USE = 3                ' Device is in use
Global Const AD03_ERR_INVALID_SOCKET = 4        ' Invalid logical Socket
Global Const AD03_ERR_RESOURCE = 5              ' Resource exhaustion
Global Const AD03_ERR_ILLEGAL_FUNCTION_CALL = 6 ' Illegal Function Call
Global Const AD03_ERR_INVALID_ARGUMENT = 7      ' Invalid argument
Global Const AD03_ERR_NUMDATA = 8               ' Invalid Number of Data
Global Const AD03_ERR_INTERNAL = 9              ' Internal Error

' other
Global Const AD03_SOCKET_AUTO = &HFFFF          ' I[gT[`
Global Const AD03_MAX_SOCKETS = 16              ' T|[g\Pbg
Global Const AD03_NUM_CHANNELS = 2              ' `l

' Device ID
Global Const AD03_DEVICE_ID = &HC0054103

' Message
Global Const WM_BUFF_FULL = 0                   ' obt@(FIFO)t
Global Const WM_CARD_REMOVAL = 1                ' J[h

' Sampling Status
Global Const AD03_STS_SAMPLING = &H1            ' TvO
Global Const AD03_STS_BUFF_FULL = &H2           ' obt@(FIFO)t
Global Const AD03_STS_HOLDOFF_ERROR = &H4       ' HOLD OFF G[

' Resource infomation structure
Global Const AD03_NMAX_MEM = 9
Global Const AD03_NMAX_IO = 20
Global Const AD03_NMAX_IRQ = 7
Global Const AD03_NMAX_DMA = 7

Type AD03RESOURCE
    dwNumMemWindows As Long                     ' Not used
    dwMemBase(1 To AD03_NMAX_MEM) As Long       ' Not used
    dwMemLength(1 To AD03_NMAX_MEM) As Long     ' Not used
    dwMemAttrib(1 To AD03_NMAX_MEM) As Long     ' Not used
    dwNumIOPorts As Long                        ' Num IO ports
    dwIOPortBase(1 To AD03_NMAX_IO) As Long     ' I/O port base
    dwIOPortLength(1 To AD03_NMAX_IO) As Long   ' I/O port length
    dwNumIRQs As Long                           ' Num IRQ info
    dwIRQRegisters(1 To AD03_NMAX_IRQ) As Long  ' IRQ list
    dwIRQAttrib(1 To AD03_NMAX_IRQ) As Long     ' IRQ Attrib list
    dwNumDMAs As Long                           ' Not used
    dwDMALst(1 To AD03_NMAX_DMA) As Long        ' Not used
    dwDMAAttrib(1 To AD03_NMAX_DMA) As Long     ' Not used
    dwReserved1(1 To 3) As Long                 ' Not used
End Type

' Mode structure
Type AD03MODE
    dwSampleTime As Long    ' Sampling time
    dwTrigMode As Long      ' Trigger mode
    dwTrigSource As Long    ' Trigger Source
    dwTrigSlope As Long     ' Trigger Slope
    dwTrigLevel As Long     ' Trigger Level
    dwTrigPosition As Long  ' Trigger Position
    dwTrigDelay As Long     ' Trigger Delay time
    dwTrigHoldOff As Long   ' Trigger HoldOff time
End Type

Public Declare Function Ad03GetVersion Lib "axpad03" (ByRef pdwDllVersion As Long, ByRef pdwVxdVersion As Long) As Long
Public Declare Function Ad03Create Lib "axpad03" (ByRef pwLogSocket As Integer, ByVal hWnd As Long, ByVal uWMBase As Long) As Long
Public Declare Function Ad03Close Lib "axpad03" (ByVal wLogSocket As Integer) As Long
Public Declare Function Ad03GetResource Lib "axpad03" (ByVal wLogSocket As Integer, ByRef pres As AD03RESOURCE) As Long
Public Declare Function Ad03SetMode Lib "axpad03" (ByVal wLogSocket As Integer, ByRef pcmode As AD03MODE) As Long
Public Declare Function Ad03StartSampling Lib "axpad03" (ByVal wLogSocket As Integer) As Long
Public Declare Function Ad03StopSampling Lib "axpad03" (ByVal wLogSocket As Integer) As Long
Public Declare Function Ad03GetSamplingStatus Lib "axpad03" (ByVal wLogSocket As Integer, ByRef pcwNumData As Long, ByRef pdwStatus As Long) As Long
Public Declare Function Ad03GetData Lib "axpad03" (ByVal wLogSocket As Integer, ByVal cwNumData As Long, ByRef pwData As Integer) As Long
Public Declare Function Ad03GetLastError Lib "axpad03" (ByVal wLogSocket As Integer) As Long
